
public class Binary {
	
	public static final int SIGN_BIT_MASK = 0b1000_0000_0000_0000_0000_0000_0000_0000;
	public static final int NUMBER_MASK =   0b0111_1111_1111_1111_1111_1111_1111_1111;

	//creates a mask which hides all but the ith least significant bit, starting at 0
	public static int bitMask(int i) {
		if(i > 32 || i < 0 ) {
			throw new RuntimeException();
		}
		else if(i == 32){
			return SIGN_BIT_MASK;
		}
		else {
			return (int)Math.round(Math.pow(2, i));
		}
	}
	
	
	public static final int LAST_3_BITS_MASK = 0b0000_0000_0000_0000_0000_0000_0000_0111; // Note that using this is equivalent to a "mod 8" operation
	
	public static void main(String[] args) {
		for(int i = 0; i != 32; ++i) {
			System.out.println(i + ": " + bitMask(i));
		}
		
		
		int negativeNumber = -123572;
		int positiveNumber = 4528;
		
		//Single & is a bitwise AND, not a logical AND
		
		System.out.println("Negative number, sign bit: " + (SIGN_BIT_MASK & negativeNumber));
		System.out.println("Positive number, sign bit: " + (SIGN_BIT_MASK & positiveNumber));
		System.out.println("Negative number, number bits: " + (NUMBER_MASK & negativeNumber));
		System.out.println("Positive number, number bits: " + (NUMBER_MASK & positiveNumber));
		System.out.println("Negative number, last 3 bits: " + (LAST_3_BITS_MASK & negativeNumber));
		System.out.println("Positive number, last 3 bits: " + (LAST_3_BITS_MASK & positiveNumber));		
		
	}

}
